#ifndef MAKE_ID
#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))
#endif

/* Libraries */
#include <libraries/mui.h>
#include <libraries/gadtools.h> /* for Barlabel in MenuItem */
#include <exec/memory.h>

/* Prototypes */
#include <proto/muimaster.h>
#include <proto/exec.h>
#ifdef __GNUC__
#include <proto/alib.h>
#else
#include <clib/alib_protos.h>
#endif /* __GNUC__ */

#include "ZeladorGUI.h"
#include "ZeladorFrases.h"

struct ObjApp * CreateApp(void)
{
	struct ObjApp * ObjectApp;

	APTR	MNlabel1Principal, MNlabel1BarLabel0, MNlabel1BarLabel1, MNPrincipalProcess;
	APTR	GROUP_ROOT_0, GR_grp_0, GR_grp_17, Space_11, IM_label_1, Space_12;
	APTR	GR_grp_3, obj_aux0, obj_aux1, GR_grp_2, GROUP_ROOT_1, GR_grp_15, GR_grp_9CCCCCC;
	APTR	LBL_Active2, Space_0, Space_15, LA_label_11CCCCCC, Space_16, LA_label_12CCCCCC;
	APTR	Space_17, LA_label_13CCCCCC, Space_18, GR_grp_27, LA_label_16, Space_31;
	APTR	LA_label_24, GR_grp_28, LA_label_23, Space_32, LA_label_25, LBL_Active;
	APTR	Space_10, LA_label_10CCCCCCCCCC, GR_grp_9CCCCCCCC, Space_6, Space_7;
	APTR	LBL_LimitConnBy, LA_label_15, Space_2, Space_3, LBL_EventBeginsAt;
	APTR	Space_4, Space_5, LBL_TryUntil, Space_8, Space_9, GR_grp_24, GR_grp_18;
	APTR	GR_grp_20, LA_label_17, LA_label_18, LA_label_19, LA_label_26, GR_grp_25;
	APTR	obj_aux2, obj_aux3, obj_aux4, obj_aux5, GR_grp_23, LA_label_20, LA_label_21;
	APTR	LA_label_22, GR_grp_26, GR_grp_23CC, LA_label_20CC, LA_label_21CC;
	APTR	LA_label_22CC, GR_grp_16;

	if (!(ObjectApp = AllocVec(sizeof(struct ObjApp),MEMF_PUBLIC|MEMF_CLEAR)))
		return(NULL);

	ObjectApp->STR_TXT_DataHoras = NULL;
	ObjectApp->STR_TXT_Status = NULL;

	ObjectApp->STR_GR_grp_13CCCC[0] = FraEventos;
	ObjectApp->STR_GR_grp_13CCCC[1] = FraHoras;
	ObjectApp->STR_GR_grp_13CCCC[2] = FraEFR;
	ObjectApp->STR_GR_grp_13CCCC[3] = FraRR;
	ObjectApp->STR_GR_grp_13CCCC[4] = NULL;
	ObjectApp->CYC_DuracTempoContent[0] = FraDuracaoMaxima;
	ObjectApp->CYC_DuracTempoContent[1] = FraHoraMaxima;
	ObjectApp->CYC_DuracTempoContent[2] = NULL;

	Space_11 = HVSpace;

	IM_label_1 = ImageObject,
		MUIA_Image_Spec, "5:Zelador.iff",
		MUIA_Image_FreeVert, TRUE,
		MUIA_Image_FreeHoriz, TRUE,
		MUIA_FixHeight, 22,
		MUIA_FixWidth, 338,
	End;

	Space_12 = HVSpace;

	GR_grp_17 = GroupObject,
		MUIA_HelpNode, "GR_grp_17",
		MUIA_Group_Horiz, TRUE,
		Child, Space_11,
		Child, IM_label_1,
		Child, Space_12,
	End;

	ObjectApp->TXT_DataHoras = TextObject,
		MUIA_Weight, 24,
		MUIA_Background, MUII_TextBack,
		MUIA_Frame, MUIV_Frame_Text,
		MUIA_Text_Contents, ObjectApp->STR_TXT_DataHoras,
		MUIA_Text_SetMin, TRUE,
	End;

	ObjectApp->CHK_EventosAtivos = CheckMark(FALSE);

	obj_aux1 = Label2(FraEventosAtivos);

	obj_aux0 = GroupObject,
		MUIA_Group_Columns, 2,
		Child, obj_aux1,
		Child, ObjectApp->CHK_EventosAtivos,
	End;

	GR_grp_3 = GroupObject,
		MUIA_HelpNode, "GR_grp_3",
		MUIA_Group_Horiz, TRUE,
		MUIA_Group_SameWidth, TRUE,
		Child, ObjectApp->TXT_DataHoras,
		Child, obj_aux0,
	End;

	ObjectApp->TXT_Status = TextObject,
		MUIA_Background, MUII_TextBack,
		MUIA_Frame, MUIV_Frame_Text,
		MUIA_Text_Contents, ObjectApp->STR_TXT_Status,
		MUIA_Text_SetMin, TRUE,
	End;

	ObjectApp->BT_FazerEvento = SimpleButton(FraFazerEvento);

	ObjectApp->BT_Config = SimpleButton(FraConfig);

	GR_grp_2 = GroupObject,
		MUIA_HelpNode, "GR_grp_2",
		MUIA_Group_Horiz, TRUE,
		MUIA_Group_SameWidth, TRUE,
		Child, ObjectApp->BT_FazerEvento,
		Child, ObjectApp->BT_Config,
	End;

	GR_grp_0 = GroupObject,
		MUIA_HelpNode, "GR_grp_0",
		Child, GR_grp_17,
		Child, GR_grp_3,
		Child, ObjectApp->TXT_Status,
		Child, GR_grp_2,
	End;

	GROUP_ROOT_0 = GroupObject,
		Child, GR_grp_0,
	End;

	ObjectApp->MN_Config = MenuitemObject,
		MUIA_Menuitem_Title, FraConfigMenu,
		MUIA_Menuitem_Shortcut, FraHKConfig,
	End;

	MNlabel1BarLabel0 = MUI_MakeObject(MUIO_Menuitem, NM_BARLABEL, 0, 0, 0);

	ObjectApp->MN_Sobre = MenuitemObject,
		MUIA_Menuitem_Title, FraSobre,
		MUIA_Menuitem_Shortcut, FraHKSobre,
	End;

	MNlabel1BarLabel1 = MUI_MakeObject(MUIO_Menuitem, NM_BARLABEL, 0, 0, 0);

	ObjectApp->MN_Sair = MenuitemObject,
		MUIA_Menuitem_Title, FraSair,
		MUIA_Menuitem_Shortcut, FraHKSair,
	End;

	MNlabel1Principal = MenuitemObject,
		MUIA_Menuitem_Title, FraMenuTit,
		MUIA_Family_Child, ObjectApp->MN_Config,
		MUIA_Family_Child, MNlabel1BarLabel0,
		MUIA_Family_Child, ObjectApp->MN_Sobre,
		MUIA_Family_Child, MNlabel1BarLabel1,
		MUIA_Family_Child, ObjectApp->MN_Sair,
	End;

	ObjectApp->MN_EFR = MenuitemObject,
		MUIA_Menuitem_Title, FraMenuEFR,
		MUIA_Menuitem_Shortcut, FraHKMenuEFR,
	End;

	ObjectApp->MN_RR = MenuitemObject,
		MUIA_Menuitem_Title, FraMenuRR,
		MUIA_Menuitem_Shortcut, FraHKMenuRR,
	End;

	MNPrincipalProcess = MenuitemObject,
		MUIA_Menuitem_Title, FraMenuTit2,
		MUIA_Family_Child, ObjectApp->MN_EFR,
		MUIA_Family_Child, ObjectApp->MN_RR,
	End;

	ObjectApp->MN_Principal = MenustripObject,
		MUIA_Family_Child, MNlabel1Principal,
		MUIA_Family_Child, MNPrincipalProcess,
	End;

	ObjectApp->Janela_Principal = WindowObject,
		MUIA_Window_Title, FraTitJanela,
		MUIA_Window_Menustrip, ObjectApp->MN_Principal,
		MUIA_Window_ID, MAKE_ID('0', 'W', 'I', 'N'),
		WindowContents, GROUP_ROOT_0,
	End;

	LBL_Active2 = Label(FraAtivo);

	Space_0 = HVSpace;

	Space_15 = HVSpace;

	ObjectApp->CHK_AutoMiami = KeyCheckMark(FALSE, 'a');

	LA_label_11CCCCCC = Label(FraAutoMiami);

	Space_16 = HVSpace;

	ObjectApp->CHK_ReceberYAM = KeyCheckMark(FALSE, 'r');

	LA_label_12CCCCCC = Label(FraRecebYAM);

	Space_17 = HVSpace;

	ObjectApp->CHK_EnviarYAM = KeyCheckMark(FALSE, 'e');

	LA_label_13CCCCCC = Label(FraEnvYAM);

	Space_18 = HVSpace;

	ObjectApp->CHK_FileRequest = KeyCheckMark(FALSE, 'f');

	LA_label_16 = Label(FraProcEFR);

	Space_31 = HVSpace;

	LA_label_24 = Label(FraRodarQdoConectado);

	GR_grp_27 = GroupObject,
		MUIA_HelpNode, "GR_grp_27",
		MUIA_Group_Horiz, TRUE,
		Child, LA_label_16,
		Child, Space_31,
		Child, LA_label_24,
	End;

	ObjectApp->CHK_EFRScanWhileConnected = KeyCheckMark(FALSE, 'i');

	ObjectApp->CHK_HabilitaRobotReply = KeyCheckMark(FALSE, 'p');

	LA_label_23 = Label(FraAutoProcRR);

	Space_32 = HVSpace;

	LA_label_25 = Label(FraRodarQdoConectado2);

	GR_grp_28 = GroupObject,
		MUIA_HelpNode, "GR_grp_28",
		MUIA_Group_Horiz, TRUE,
		Child, LA_label_23,
		Child, Space_32,
		Child, LA_label_25,
	End;

	ObjectApp->CHK_RRScanWhileConnected = KeyCheckMark(FALSE, 'n');

	LBL_Active = Label(FraAtivo2);

	Space_10 = HVSpace;

	LA_label_10CCCCCCCCCC = Label(FraEsperar);

	ObjectApp->CHK_Ativo1 = CheckMark(FALSE);

	ObjectApp->STR_Path1 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Path1",
		MUIA_String_MaxLen, 128,
	End;

	ObjectApp->CHK_Espera1 = CheckMark(FALSE);

	ObjectApp->CHK_Ativo2 = CheckMark(FALSE);

	ObjectApp->STR_Path2 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Path2",
		MUIA_String_MaxLen, 128,
	End;

	ObjectApp->CHK_Espera2 = CheckMark(FALSE);

	ObjectApp->CHK_Ativo3 = CheckMark(FALSE);

	ObjectApp->STR_Path3 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Path3",
		MUIA_String_MaxLen, 128,
	End;

	ObjectApp->CHK_Espera3 = CheckMark(FALSE);

	GR_grp_9CCCCCC = GroupObject,
		MUIA_HelpNode, "GR_grp_9CCCCCC",
		MUIA_Group_Columns, 3,
		MUIA_Group_SameHeight, TRUE,
		Child, LBL_Active2,
		Child, Space_0,
		Child, Space_15,
		Child, ObjectApp->CHK_AutoMiami,
		Child, LA_label_11CCCCCC,
		Child, Space_16,
		Child, ObjectApp->CHK_ReceberYAM,
		Child, LA_label_12CCCCCC,
		Child, Space_17,
		Child, ObjectApp->CHK_EnviarYAM,
		Child, LA_label_13CCCCCC,
		Child, Space_18,
		Child, ObjectApp->CHK_FileRequest,
		Child, GR_grp_27,
		Child, ObjectApp->CHK_EFRScanWhileConnected,
		Child, ObjectApp->CHK_HabilitaRobotReply,
		Child, GR_grp_28,
		Child, ObjectApp->CHK_RRScanWhileConnected,
		Child, LBL_Active,
		Child, Space_10,
		Child, LA_label_10CCCCCCCCCC,
		Child, ObjectApp->CHK_Ativo1,
		Child, ObjectApp->STR_Path1,
		Child, ObjectApp->CHK_Espera1,
		Child, ObjectApp->CHK_Ativo2,
		Child, ObjectApp->STR_Path2,
		Child, ObjectApp->CHK_Espera2,
		Child, ObjectApp->CHK_Ativo3,
		Child, ObjectApp->STR_Path3,
		Child, ObjectApp->CHK_Espera3,
	End;

	Space_6 = HVSpace;

	Space_7 = HVSpace;

	LBL_LimitConnBy = Label(FraLimitarPor);

	LA_label_15 = Label(FraHHMM24h);

	ObjectApp->CYC_DuracTempo = CycleObject,
		MUIA_HelpNode, "CYC_DuracTempo",
		MUIA_ControlChar, 'l',
		MUIA_Cycle_Entries, ObjectApp->CYC_DuracTempoContent,
	End;

	ObjectApp->STR_LimiteHoras = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_ControlChar, 'm',
		MUIA_HelpNode, "STR_LimiteHoras",
		MUIA_String_Contents, "0000",
		MUIA_String_Accept, "0123456789",
		MUIA_String_MaxLen, 5,
	End;

	Space_2 = HVSpace;

	Space_3 = HVSpace;

	LBL_EventBeginsAt = Label(FraEventoComecaAs);

	ObjectApp->STR_InicioEvento = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_ControlChar, 'i',
		MUIA_HelpNode, "STR_InicioEvento",
		MUIA_String_Contents, "0000",
		MUIA_String_Accept, "0123456789",
		MUIA_String_MaxLen, 5,
	End;

	Space_4 = HVSpace;

	Space_5 = HVSpace;

	LBL_TryUntil = Label(FraTentarAte);

	ObjectApp->STR_TentarAte = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_ControlChar, 't',
		MUIA_HelpNode, "STR_TentarAte",
		MUIA_String_Contents, "0000",
		MUIA_String_Accept, "0123456789",
		MUIA_String_MaxLen, 5,
	End;

	Space_8 = HVSpace;

	Space_9 = HVSpace;

	GR_grp_9CCCCCCCC = GroupObject,
		MUIA_HelpNode, "GR_grp_9CCCCCCCC",
		MUIA_Group_Columns, 2,
		Child, Space_6,
		Child, Space_7,
		Child, LBL_LimitConnBy,
		Child, LA_label_15,
		Child, ObjectApp->CYC_DuracTempo,
		Child, ObjectApp->STR_LimiteHoras,
		Child, Space_2,
		Child, Space_3,
		Child, LBL_EventBeginsAt,
		Child, ObjectApp->STR_InicioEvento,
		Child, Space_4,
		Child, Space_5,
		Child, LBL_TryUntil,
		Child, ObjectApp->STR_TentarAte,
		Child, Space_8,
		Child, Space_9,
	End;

	LA_label_17 = Label(FraTopicoInterceptar);

	ObjectApp->STR_AssuntoIntercepta = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_ControlChar, 'i',
		MUIA_HelpNode, "STR_AssuntoIntercepta",
	End;

	LA_label_18 = Label(FraTxtApresentacao);

	ObjectApp->STR_POP_TxtApresentacao = String("", 80);

	ObjectApp->POP_TxtApresentacao = PopButton(MUII_PopFile);

	ObjectApp->POP_TxtApresentacao = PopaslObject,
		MUIA_HelpNode, "POP_TxtApresentacao",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_TxtApresentacao,
		MUIA_Popstring_Button, ObjectApp->POP_TxtApresentacao,
	End;

	LA_label_19 = Label(FraTxtAEnviar);

	ObjectApp->STR_POP_EnviandoArq = String("", 80);

	ObjectApp->POP_EnviandoArq = PopButton(MUII_PopFile);

	ObjectApp->POP_EnviandoArq = PopaslObject,
		MUIA_HelpNode, "POP_EnviandoArq",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_EnviandoArq,
		MUIA_Popstring_Button, ObjectApp->POP_EnviandoArq,
	End;

	LA_label_26 = Label(FraReqMaxEvento);

	ObjectApp->STR_MaxPedidoKbEvento = StringObject,
		MUIA_Weight, 2,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_ControlChar, 'm',
		MUIA_HelpNode, "STR_MaxPedidoKbEvento",
		MUIA_String_Accept, "0123456789",
		MUIA_String_MaxLen, 9,
	End;

	ObjectApp->STR_RecusaAPartirKB = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_ControlChar, 'f',
		MUIA_HelpNode, "STR_RecusaAPartirKB",
		MUIA_String_Accept, "0123456789",
		MUIA_String_MaxLen, 9,
	End;

	obj_aux3 = KeyLabel2(FraComRecusarA, 'f');

	obj_aux2 = GroupObject,
		MUIA_Group_Columns, 2,
		MUIA_Weight, 4,
		Child, obj_aux3,
		Child, ObjectApp->STR_RecusaAPartirKB,
	End;

	ObjectApp->STR_MaxDaysValidID = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_ControlChar, 'd',
		MUIA_HelpNode, "STR_MaxDaysValidID",
		MUIA_String_Accept, "0123456789",
		MUIA_String_MaxLen, 4,
	End;

	obj_aux5 = KeyLabel2(FraMaxDiasProc, 'd');

	obj_aux4 = GroupObject,
		MUIA_Group_Columns, 2,
		MUIA_Weight, 2,
		Child, obj_aux5,
		Child, ObjectApp->STR_MaxDaysValidID,
	End;

	GR_grp_25 = GroupObject,
		MUIA_HelpNode, "GR_grp_25",
		MUIA_Group_Horiz, TRUE,
		Child, ObjectApp->STR_MaxPedidoKbEvento,
		Child, obj_aux2,
		Child, obj_aux4,
	End;

	GR_grp_20 = GroupObject,
		MUIA_HelpNode, "GR_grp_20",
		MUIA_Group_Columns, 2,
		Child, LA_label_17,
		Child, ObjectApp->STR_AssuntoIntercepta,
		Child, LA_label_18,
		Child, ObjectApp->POP_TxtApresentacao,
		Child, LA_label_19,
		Child, ObjectApp->POP_EnviandoArq,
		Child, LA_label_26,
		Child, GR_grp_25,
	End;

	GR_grp_18 = GroupObject,
		MUIA_HelpNode, "GR_grp_18",
		Child, GR_grp_20,
	End;

	LA_label_20 = Label(FraAtivadoTab);

	LA_label_21 = Label(FraDescricaoArq);

	LA_label_22 = Label(FraArqPathEFR);

	ObjectApp->CHK_Req0 = CheckMark(FALSE);

	ObjectApp->STR_Req0 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Req0",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_Req0 = String("", 80);

	ObjectApp->POP_Req0 = PopButton(MUII_PopFile);

	ObjectApp->POP_Req0 = PopaslObject,
		MUIA_HelpNode, "POP_Req0",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_Req0,
		MUIA_Popstring_Button, ObjectApp->POP_Req0,
	End;

	ObjectApp->CHK_Req1 = CheckMark(FALSE);

	ObjectApp->STR_Req1 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Req1",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_Req1 = String("", 80);

	ObjectApp->POP_Req1 = PopButton(MUII_PopFile);

	ObjectApp->POP_Req1 = PopaslObject,
		MUIA_HelpNode, "POP_Req1",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_Req1,
		MUIA_Popstring_Button, ObjectApp->POP_Req1,
	End;

	ObjectApp->CHK_Req2 = CheckMark(FALSE);

	ObjectApp->STR_Req2 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Req2",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_Req2 = String("", 80);

	ObjectApp->POP_Req2 = PopButton(MUII_PopFile);

	ObjectApp->POP_Req2 = PopaslObject,
		MUIA_HelpNode, "POP_Req2",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_Req2,
		MUIA_Popstring_Button, ObjectApp->POP_Req2,
	End;

	ObjectApp->CHK_Req3 = CheckMark(FALSE);

	ObjectApp->STR_Req3 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Req3",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_Req3 = String("", 80);

	ObjectApp->POP_Req3 = PopButton(MUII_PopFile);

	ObjectApp->POP_Req3 = PopaslObject,
		MUIA_HelpNode, "POP_Req3",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_Req3,
		MUIA_Popstring_Button, ObjectApp->POP_Req3,
	End;

	ObjectApp->CHK_Req4 = CheckMark(FALSE);

	ObjectApp->STR_Req4 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Req4",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_Req4 = String("", 80);

	ObjectApp->POP_Req4 = PopButton(MUII_PopFile);

	ObjectApp->POP_Req4 = PopaslObject,
		MUIA_HelpNode, "POP_Req4",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_Req4,
		MUIA_Popstring_Button, ObjectApp->POP_Req4,
	End;

	ObjectApp->CHK_Req5 = CheckMark(FALSE);

	ObjectApp->STR_Req5 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Req5",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_Req5 = String("", 80);

	ObjectApp->POP_Req5 = PopButton(MUII_PopFile);

	ObjectApp->POP_Req5 = PopaslObject,
		MUIA_HelpNode, "POP_Req5",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_Req5,
		MUIA_Popstring_Button, ObjectApp->POP_Req5,
	End;

	ObjectApp->CHK_Req6 = CheckMark(FALSE);

	ObjectApp->STR_Req6 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Req6",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_Req6 = String("", 80);

	ObjectApp->POP_Req6 = PopButton(MUII_PopFile);

	ObjectApp->POP_Req6 = PopaslObject,
		MUIA_HelpNode, "POP_Req6",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_Req6,
		MUIA_Popstring_Button, ObjectApp->POP_Req6,
	End;

	ObjectApp->CHK_Req7 = CheckMark(FALSE);

	ObjectApp->STR_Req7 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Req7",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_Req7 = String("", 80);

	ObjectApp->POP_Req7 = PopButton(MUII_PopFile);

	ObjectApp->POP_Req7 = PopaslObject,
		MUIA_HelpNode, "POP_Req7",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_Req7,
		MUIA_Popstring_Button, ObjectApp->POP_Req7,
	End;

	ObjectApp->CHK_Req8 = CheckMark(FALSE);

	ObjectApp->STR_Req8 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Req8",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_Req8 = String("", 80);

	ObjectApp->POP_Req8 = PopButton(MUII_PopFile);

	ObjectApp->POP_Req8 = PopaslObject,
		MUIA_HelpNode, "POP_Req8",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_Req8,
		MUIA_Popstring_Button, ObjectApp->POP_Req8,
	End;

	ObjectApp->CHK_Req9 = CheckMark(FALSE);

	ObjectApp->STR_Req9 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_Req9",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_Req9 = String("", 80);

	ObjectApp->POP_Req9 = PopButton(MUII_PopFile);

	ObjectApp->POP_Req9 = PopaslObject,
		MUIA_HelpNode, "POP_Req9",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_Req9,
		MUIA_Popstring_Button, ObjectApp->POP_Req9,
	End;

	GR_grp_23 = VirtgroupObject,
		VirtualFrame,
		MUIA_HelpNode, "GR_grp_23",
		MUIA_Background, MUII_FILL,
		MUIA_Frame, MUIV_Frame_Text,
		MUIA_Group_Columns, 3,
		Child, LA_label_20,
		Child, LA_label_21,
		Child, LA_label_22,
		Child, ObjectApp->CHK_Req0,
		Child, ObjectApp->STR_Req0,
		Child, ObjectApp->POP_Req0,
		Child, ObjectApp->CHK_Req1,
		Child, ObjectApp->STR_Req1,
		Child, ObjectApp->POP_Req1,
		Child, ObjectApp->CHK_Req2,
		Child, ObjectApp->STR_Req2,
		Child, ObjectApp->POP_Req2,
		Child, ObjectApp->CHK_Req3,
		Child, ObjectApp->STR_Req3,
		Child, ObjectApp->POP_Req3,
		Child, ObjectApp->CHK_Req4,
		Child, ObjectApp->STR_Req4,
		Child, ObjectApp->POP_Req4,
		Child, ObjectApp->CHK_Req5,
		Child, ObjectApp->STR_Req5,
		Child, ObjectApp->POP_Req5,
		Child, ObjectApp->CHK_Req6,
		Child, ObjectApp->STR_Req6,
		Child, ObjectApp->POP_Req6,
		Child, ObjectApp->CHK_Req7,
		Child, ObjectApp->STR_Req7,
		Child, ObjectApp->POP_Req7,
		Child, ObjectApp->CHK_Req8,
		Child, ObjectApp->STR_Req8,
		Child, ObjectApp->POP_Req8,
		Child, ObjectApp->CHK_Req9,
		Child, ObjectApp->STR_Req9,
		Child, ObjectApp->POP_Req9,
	End;

	GR_grp_23 = ScrollgroupObject,
		MUIA_Scrollgroup_Contents, GR_grp_23,
		MUIA_Scrollgroup_FreeHoriz, FALSE,
	End;

	GR_grp_24 = GroupObject,
		MUIA_HelpNode, "GR_grp_24",
		Child, GR_grp_18,
		Child, GR_grp_23,
	End;

	LA_label_20CC = Label(FraAtivadoTab2);

	LA_label_21CC = Label(FraTopIntercepRR);

	LA_label_22CC = Label(FraArqTxtEnviar);

	ObjectApp->CHK_RR0 = CheckMark(FALSE);

	ObjectApp->STR_RR0 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_RR0",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_RR0 = String("", 80);

	ObjectApp->POP_RR0 = PopButton(MUII_PopFile);

	ObjectApp->POP_RR0 = PopaslObject,
		MUIA_HelpNode, "POP_RR0",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_RR0,
		MUIA_Popstring_Button, ObjectApp->POP_RR0,
	End;

	ObjectApp->CHK_RR1 = CheckMark(FALSE);

	ObjectApp->STR_RR1 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_RR1",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_RR1 = String("", 80);

	ObjectApp->POP_RR1 = PopButton(MUII_PopFile);

	ObjectApp->POP_RR1 = PopaslObject,
		MUIA_HelpNode, "POP_RR1",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_RR1,
		MUIA_Popstring_Button, ObjectApp->POP_RR1,
	End;

	ObjectApp->CHK_RR2 = CheckMark(FALSE);

	ObjectApp->STR_RR2 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_RR2",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_RR2 = String("", 80);

	ObjectApp->POP_RR2 = PopButton(MUII_PopFile);

	ObjectApp->POP_RR2 = PopaslObject,
		MUIA_HelpNode, "POP_RR2",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_RR2,
		MUIA_Popstring_Button, ObjectApp->POP_RR2,
	End;

	ObjectApp->CHK_RR3 = CheckMark(FALSE);

	ObjectApp->STR_RR3 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_RR3",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_RR3 = String("", 80);

	ObjectApp->POP_RR3 = PopButton(MUII_PopFile);

	ObjectApp->POP_RR3 = PopaslObject,
		MUIA_HelpNode, "POP_RR3",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_RR3,
		MUIA_Popstring_Button, ObjectApp->POP_RR3,
	End;

	ObjectApp->CHK_RR4 = CheckMark(FALSE);

	ObjectApp->STR_RR4 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_RR4",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_RR4 = String("", 80);

	ObjectApp->POP_RR4 = PopButton(MUII_PopFile);

	ObjectApp->POP_RR4 = PopaslObject,
		MUIA_HelpNode, "POP_RR4",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_RR4,
		MUIA_Popstring_Button, ObjectApp->POP_RR4,
	End;

	ObjectApp->CHK_RR5 = CheckMark(FALSE);

	ObjectApp->STR_RR5 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_RR5",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_RR5 = String("", 80);

	ObjectApp->POP_RR5 = PopButton(MUII_PopFile);

	ObjectApp->POP_RR5 = PopaslObject,
		MUIA_HelpNode, "POP_RR5",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_RR5,
		MUIA_Popstring_Button, ObjectApp->POP_RR5,
	End;

	ObjectApp->CHK_RR6 = CheckMark(FALSE);

	ObjectApp->STR_RR6 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_RR6",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_RR6 = String("", 80);

	ObjectApp->POP_RR6 = PopButton(MUII_PopFile);

	ObjectApp->POP_RR6 = PopaslObject,
		MUIA_HelpNode, "POP_RR6",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_RR6,
		MUIA_Popstring_Button, ObjectApp->POP_RR6,
	End;

	ObjectApp->CHK_RR7 = CheckMark(FALSE);

	ObjectApp->STR_RR7 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_RR7",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_RR7 = String("f", 80);

	ObjectApp->POP_RR7 = PopButton(MUII_PopFile);

	ObjectApp->POP_RR7 = PopaslObject,
		MUIA_HelpNode, "POP_RR7",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_RR7,
		MUIA_Popstring_Button, ObjectApp->POP_RR7,
	End;

	ObjectApp->CHK_RR8 = CheckMark(FALSE);

	ObjectApp->STR_RR8 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_RR8",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_RR8 = String("", 80);

	ObjectApp->POP_RR8 = PopButton(MUII_PopFile);

	ObjectApp->POP_RR8 = PopaslObject,
		MUIA_HelpNode, "POP_RR8",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_RR8,
		MUIA_Popstring_Button, ObjectApp->POP_RR8,
	End;

	ObjectApp->CHK_RR9 = CheckMark(FALSE);

	ObjectApp->STR_RR9 = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_RR9",
		MUIA_String_Reject, "\\\"*?#/'",
	End;

	ObjectApp->STR_POP_RR9 = String("", 80);

	ObjectApp->POP_RR9 = PopButton(MUII_PopFile);

	ObjectApp->POP_RR9 = PopaslObject,
		MUIA_HelpNode, "POP_RR9",
		MUIA_Popasl_Type, 0,
		MUIA_Popstring_String, ObjectApp->STR_POP_RR9,
		MUIA_Popstring_Button, ObjectApp->POP_RR9,
	End;

	GR_grp_23CC = VirtgroupObject,
		VirtualFrame,
		MUIA_HelpNode, "GR_grp_23CC",
		MUIA_Background, MUII_FILL,
		MUIA_Frame, MUIV_Frame_Text,
		MUIA_Group_Columns, 3,
		Child, LA_label_20CC,
		Child, LA_label_21CC,
		Child, LA_label_22CC,
		Child, ObjectApp->CHK_RR0,
		Child, ObjectApp->STR_RR0,
		Child, ObjectApp->POP_RR0,
		Child, ObjectApp->CHK_RR1,
		Child, ObjectApp->STR_RR1,
		Child, ObjectApp->POP_RR1,
		Child, ObjectApp->CHK_RR2,
		Child, ObjectApp->STR_RR2,
		Child, ObjectApp->POP_RR2,
		Child, ObjectApp->CHK_RR3,
		Child, ObjectApp->STR_RR3,
		Child, ObjectApp->POP_RR3,
		Child, ObjectApp->CHK_RR4,
		Child, ObjectApp->STR_RR4,
		Child, ObjectApp->POP_RR4,
		Child, ObjectApp->CHK_RR5,
		Child, ObjectApp->STR_RR5,
		Child, ObjectApp->POP_RR5,
		Child, ObjectApp->CHK_RR6,
		Child, ObjectApp->STR_RR6,
		Child, ObjectApp->POP_RR6,
		Child, ObjectApp->CHK_RR7,
		Child, ObjectApp->STR_RR7,
		Child, ObjectApp->POP_RR7,
		Child, ObjectApp->CHK_RR8,
		Child, ObjectApp->STR_RR8,
		Child, ObjectApp->POP_RR8,
		Child, ObjectApp->CHK_RR9,
		Child, ObjectApp->STR_RR9,
		Child, ObjectApp->POP_RR9,
	End;

	GR_grp_23CC = ScrollgroupObject,
		MUIA_Scrollgroup_Contents, GR_grp_23CC,
		MUIA_Scrollgroup_FreeHoriz, FALSE,
	End;

	GR_grp_26 = GroupObject,
		MUIA_HelpNode, "GR_grp_26",
		Child, GR_grp_23CC,
	End;

	ObjectApp->GR_grp_13CCCC = RegisterObject,
		MUIA_Register_Titles, ObjectApp->STR_GR_grp_13CCCC,
		MUIA_HelpNode, "GR_grp_13CCCC",
		Child, GR_grp_9CCCCCC,
		Child, GR_grp_9CCCCCCCC,
		Child, GR_grp_24,
		Child, GR_grp_26,
	End;

	ObjectApp->BT_ConfGravar = SimpleButton(FraGravar);

	ObjectApp->BT_ConfUsar = SimpleButton(FraUsar);

	ObjectApp->BT_ConfCancelar = SimpleButton(FraCancelar);

	GR_grp_16 = GroupObject,
		MUIA_HelpNode, "GR_grp_16",
		MUIA_Group_Horiz, TRUE,
		Child, ObjectApp->BT_ConfGravar,
		Child, ObjectApp->BT_ConfUsar,
		Child, ObjectApp->BT_ConfCancelar,
	End;

	GR_grp_15 = GroupObject,
		MUIA_HelpNode, "GR_grp_15",
		Child, ObjectApp->GR_grp_13CCCC,
		Child, GR_grp_16,
	End;

	GROUP_ROOT_1 = GroupObject,
		Child, GR_grp_15,
	End;

	ObjectApp->Janela_Config = WindowObject,
		MUIA_Window_Title, FraZeladorConfig,
		MUIA_Window_ID, MAKE_ID('1', 'W', 'I', 'N'),
		MUIA_Window_NoMenus, TRUE,
		WindowContents, GROUP_ROOT_1,
	End;

	ObjectApp->App = ApplicationObject,
		MUIA_Application_Author, "Daniel Mealha Cabrita",
		MUIA_Application_Base, "ZeladorBase",
		MUIA_Application_Title, "Zelador",
		MUIA_Application_Version, "$VER: Zelador 1.22 (15.08.1999)",
		MUIA_Application_Copyright, "Daniel Mealha Cabrita",
		SubWindow, ObjectApp->Janela_Principal,
		SubWindow, ObjectApp->Janela_Config,
	End;


	if (!ObjectApp->App)
	{
		FreeVec(ObjectApp);
		return(NULL);
	}

	DoMethod(ObjectApp->MN_Config,
		MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_Open, TRUE
		);

	DoMethod(ObjectApp->MN_Sobre,
		MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
		ObjectApp->App,
		2,
		MUIM_Application_ReturnID, AboutPedido
		);

	DoMethod(ObjectApp->MN_Sair,
		MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
		ObjectApp->App,
		2,
		MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit
		);

	DoMethod(ObjectApp->MN_EFR,
		MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
		ObjectApp->App,
		2,
		MUIM_Application_ReturnID, Processar_EFR
		);

	DoMethod(ObjectApp->MN_RR,
		MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
		ObjectApp->App,
		2,
		MUIM_Application_ReturnID, Processar_RR
		);

	DoMethod(ObjectApp->Janela_Principal,
		MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
		ObjectApp->App,
		2,
		MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit
		);

	DoMethod(ObjectApp->BT_FazerEvento,
		MUIM_Notify, MUIA_Pressed, FALSE,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_Open, FALSE
		);

	DoMethod(ObjectApp->BT_FazerEvento,
		MUIM_Notify, MUIA_Pressed, FALSE,
		ObjectApp->App,
		2,
		MUIM_Application_ReturnID, FazerEventoAgora
		);

	DoMethod(ObjectApp->BT_Config,
		MUIM_Notify, MUIA_Pressed, FALSE,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_Open, TRUE
		);

	DoMethod(ObjectApp->Janela_Principal,
		MUIM_Window_SetCycleChain, ObjectApp->CHK_EventosAtivos,
		ObjectApp->BT_FazerEvento,
		ObjectApp->BT_Config,
		0
		);

	DoMethod(ObjectApp->Janela_Config,
		MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_Open, FALSE
		);

	DoMethod(ObjectApp->STR_Path1,
		MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_ActiveObject, ObjectApp->STR_Path2
		);

	DoMethod(ObjectApp->STR_Path2,
		MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_ActiveObject, ObjectApp->STR_Path3
		);

	DoMethod(ObjectApp->STR_Path3,
		MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_ActiveObject, ObjectApp->STR_Path1
		);

	DoMethod(ObjectApp->STR_LimiteHoras,
		MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_ActiveObject, ObjectApp->STR_InicioEvento
		);

	DoMethod(ObjectApp->STR_InicioEvento,
		MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_ActiveObject, ObjectApp->STR_TentarAte
		);

	DoMethod(ObjectApp->STR_TentarAte,
		MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_ActiveObject, ObjectApp->STR_LimiteHoras
		);

	DoMethod(ObjectApp->STR_AssuntoIntercepta,
		MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_ActiveObject, ObjectApp->STR_MaxPedidoKbEvento
		);

	DoMethod(ObjectApp->STR_MaxPedidoKbEvento,
		MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_ActiveObject, ObjectApp->STR_RecusaAPartirKB
		);

	DoMethod(ObjectApp->STR_RecusaAPartirKB,
		MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_ActiveObject, ObjectApp->STR_MaxDaysValidID
		);

	DoMethod(ObjectApp->STR_MaxDaysValidID,
		MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_ActiveObject, ObjectApp->STR_AssuntoIntercepta
		);

	DoMethod(ObjectApp->BT_ConfGravar,
		MUIM_Notify, MUIA_Pressed, FALSE,
		ObjectApp->App,
		2,
		MUIM_Application_ReturnID, ConfGravar
		);

	DoMethod(ObjectApp->BT_ConfGravar,
		MUIM_Notify, MUIA_Pressed, FALSE,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_Open, FALSE
		);

	DoMethod(ObjectApp->BT_ConfUsar,
		MUIM_Notify, MUIA_Pressed, FALSE,
		ObjectApp->App,
		2,
		MUIM_Application_ReturnID, ConfUsar
		);

	DoMethod(ObjectApp->BT_ConfUsar,
		MUIM_Notify, MUIA_Pressed, FALSE,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_Open, FALSE
		);

	DoMethod(ObjectApp->BT_ConfCancelar,
		MUIM_Notify, MUIA_Pressed, FALSE,
		ObjectApp->App,
		2,
		MUIM_Application_ReturnID, ConfCancelar
		);

	DoMethod(ObjectApp->BT_ConfCancelar,
		MUIM_Notify, MUIA_Pressed, FALSE,
		ObjectApp->Janela_Config,
		3,
		MUIM_Set, MUIA_Window_Open, FALSE
		);

	DoMethod(ObjectApp->Janela_Config,
		MUIM_Window_SetCycleChain, ObjectApp->GR_grp_13CCCC,
		ObjectApp->CHK_AutoMiami,
		ObjectApp->CHK_ReceberYAM,
		ObjectApp->CHK_EnviarYAM,
		ObjectApp->CHK_FileRequest,
		ObjectApp->CHK_EFRScanWhileConnected,
		ObjectApp->CHK_HabilitaRobotReply,
		ObjectApp->CHK_RRScanWhileConnected,
		ObjectApp->CHK_Ativo1,
		ObjectApp->STR_Path1,
		ObjectApp->CHK_Espera1,
		ObjectApp->CHK_Ativo2,
		ObjectApp->STR_Path2,
		ObjectApp->CHK_Espera2,
		ObjectApp->CHK_Ativo3,
		ObjectApp->STR_Path3,
		ObjectApp->CHK_Espera3,
		ObjectApp->CYC_DuracTempo,
		ObjectApp->STR_LimiteHoras,
		ObjectApp->STR_InicioEvento,
		ObjectApp->STR_TentarAte,
		ObjectApp->STR_AssuntoIntercepta,
		ObjectApp->POP_TxtApresentacao,
		ObjectApp->POP_EnviandoArq,
		ObjectApp->STR_MaxPedidoKbEvento,
		ObjectApp->STR_RecusaAPartirKB,
		ObjectApp->STR_MaxDaysValidID,
		ObjectApp->CHK_Req0,
		ObjectApp->STR_Req0,
		ObjectApp->POP_Req0,
		ObjectApp->CHK_Req1,
		ObjectApp->STR_Req1,
		ObjectApp->POP_Req1,
		ObjectApp->CHK_Req2,
		ObjectApp->STR_Req2,
		ObjectApp->POP_Req2,
		ObjectApp->CHK_Req3,
		ObjectApp->STR_Req3,
		ObjectApp->POP_Req3,
		ObjectApp->CHK_Req4,
		ObjectApp->STR_Req4,
		ObjectApp->POP_Req4,
		ObjectApp->CHK_Req5,
		ObjectApp->STR_Req5,
		ObjectApp->POP_Req5,
		ObjectApp->CHK_Req6,
		ObjectApp->STR_Req6,
		ObjectApp->POP_Req6,
		ObjectApp->CHK_Req7,
		ObjectApp->STR_Req7,
		ObjectApp->POP_Req7,
		ObjectApp->CHK_Req8,
		ObjectApp->STR_Req8,
		ObjectApp->POP_Req8,
		ObjectApp->CHK_Req9,
		ObjectApp->STR_Req9,
		ObjectApp->POP_Req9,
		ObjectApp->CHK_RR0,
		ObjectApp->STR_RR0,
		ObjectApp->POP_RR0,
		ObjectApp->CHK_RR1,
		ObjectApp->STR_RR1,
		ObjectApp->POP_RR1,
		ObjectApp->CHK_RR2,
		ObjectApp->STR_RR2,
		ObjectApp->POP_RR2,
		ObjectApp->CHK_RR3,
		ObjectApp->STR_RR3,
		ObjectApp->POP_RR3,
		ObjectApp->CHK_RR4,
		ObjectApp->STR_RR4,
		ObjectApp->POP_RR4,
		ObjectApp->CHK_RR5,
		ObjectApp->STR_RR5,
		ObjectApp->POP_RR5,
		ObjectApp->CHK_RR6,
		ObjectApp->STR_RR6,
		ObjectApp->POP_RR6,
		ObjectApp->CHK_RR7,
		ObjectApp->STR_RR7,
		ObjectApp->POP_RR7,
		ObjectApp->CHK_RR8,
		ObjectApp->STR_RR8,
		ObjectApp->POP_RR8,
		ObjectApp->CHK_RR9,
		ObjectApp->STR_RR9,
		ObjectApp->POP_RR9,
		ObjectApp->BT_ConfGravar,
		ObjectApp->BT_ConfUsar,
		ObjectApp->BT_ConfCancelar,
		0
		);

	set(ObjectApp->Janela_Principal,
		MUIA_Window_Open, TRUE
		);


	return(ObjectApp);
}

void DisposeApp(struct ObjApp * ObjectApp)
{
	MUI_DisposeObject(ObjectApp->App);
	FreeVec(ObjectApp);
}
